Index: /trunk/IPs/systemC/processor/Morpheo/Common/include/Types.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/include/Types.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/include/Types.h	(revision 88)
@@ -1,4 +1,4 @@
-#ifndef morpheo_Type
-#define morpheo_Type
+#ifndef Morpheo_Type_h
+#define Morpheo_Type_h
 
 /*
@@ -34,19 +34,19 @@
 // #endif
 
-#define SC_CLOCK                 sc_in_clk       
-// #define SC_INTERNAL(type)        type
-// #define SC_REGISTER(type)        sc_signal<type >
-// #define SC_SIGNAL(type)          sc_signal<type >
-#define SC_IN(type)              sc_in    <type >
-#define SC_OUT(type)             sc_out   <type >
+#  define SC_CLOCK                 sc_in_clk       
+//#define SC_INTERNAL(type)        type
+//#define SC_REGISTER(type)        sc_signal<type >
+//#define SC_SIGNAL(type)          sc_signal<type >
+#  define SC_IN(type)              sc_in    <type >
+#  define SC_OUT(type)             sc_out   <type >
 			         
-#define PORT_READ(sig)           sig->read()
-#define PORT_WRITE(sig,val)      sig->write(val)
-// #define INTERNAL_READ(sig)       (*sig)
-// #define INTERNAL_WRITE(sig,val)  (*sig) = val
-// #define SIGNAL_READ(sig)         sig->read()
-// #define SIGNAL_WRITE(sig,val)    sig->write(val)
-// #define REGISTER_READ(sig)       sig->read()
-// #define REGISTER_WRITE(sig,val)  sig->write(val)
+#  define PORT_READ(sig)           sig->read()
+#  define PORT_WRITE(sig,val)      sig->write(val)
+//#define INTERNAL_READ(sig)       (*sig)
+//#define INTERNAL_WRITE(sig,val)  (*sig) = val
+//#define SIGNAL_READ(sig)         sig->read()
+//#define SIGNAL_WRITE(sig,val)    sig->write(val)
+//#define REGISTER_READ(sig)       sig->read()
+//#define REGISTER_WRITE(sig,val)  sig->write(val)
 
 #endif  
Index: /trunk/IPs/systemC/processor/Morpheo/Common/src/Debug.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/src/Debug.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/src/Debug.cpp	(revision 88)
@@ -7,7 +7,12 @@
 
 #include "Common/include/Debug.h"
+#include "Common/include/Environment.h"
+
+namespace morpheo {
 
 static uint32_t _debug_depth = 0;
 
+#undef  FUNCTION
+#define FUNCTION "debug_tab"
 std::string debug_tab (void)
 {
@@ -15,4 +20,6 @@
 }
 
+#undef  FUNCTION
+#define FUNCTION "debug_tab_inc"
 void debug_tab_inc (void)
 {
@@ -20,6 +27,10 @@
 }
 
+#undef  FUNCTION
+#define FUNCTION "debug_tab_dec"
 void debug_tab_dec (void)
 {
 //   _debug_depth --;
 }
+
+}; // end namespace morpheo
Index: /trunk/IPs/systemC/processor/Morpheo/Common/src/Environment.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/src/Environment.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/src/Environment.cpp	(revision 88)
@@ -0,0 +1,104 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Common/include/Environment.h"
+#include "Common/include/ErrorMorpheo.h"
+#include "Common/include/Debug.h"
+#include <sys/stat.h>
+
+namespace morpheo {
+
+static bool environment_initialized;
+std::string MORPHEO_HOME;
+std::string MORPHEO_TOPLEVEL;
+
+#undef  FUNCTION
+#define FUNCTION "environment"
+void environment (void)
+{
+  if (not environment_initialized)
+    {
+      {
+        char * toplevel = getenv("MORPHEO_TOPLEVEL");
+        
+        if (toplevel == NULL)
+          throw ERRORMORPHEO(FUNCTION,_("Error morpheo environment is not positioned.\n"));
+
+        MORPHEO_TOPLEVEL = toplevel;
+      }
+
+      {
+        char * home = getenv("MORPHEO_HOME");
+        
+        if (home == NULL)
+          throw ERRORMORPHEO(FUNCTION,_("Error morpheo environment is not positioned.\n"));
+
+        MORPHEO_HOME = home;
+      }
+
+      environment_initialized = true;
+    }
+}
+
+static bool directory_initialized;
+std::string MORPHEO_STATISTICS;
+std::string MORPHEO_VHDL;
+std::string MORPHEO_POSITION;
+std::string MORPHEO_LOG;
+
+#undef  FUNCTION
+#define FUNCTION "exist_directory"
+void exist_directory (std::string dir)
+{
+//   struct stat *buf;
+//   int res = stat(dir.c_str(), buf);
+//   if ((res != 0) or not S_ISDIR(buf->st_mode))
+//     throw ERRORMORPHEO(FUNCTION,toString(_("Error in opening directory \"%s\".\n"),dir.c_str()));
+
+
+  char * pwd = getenv("PWD");
+  if (chdir(dir.c_str())!=0)
+    throw ERRORMORPHEO(FUNCTION,toString(_("Error in opening directory \"%s\".\n"),dir.c_str()));
+  chdir(pwd);
+}
+
+#undef  FUNCTION
+#define FUNCTION "directory_init"
+void directory_init (std::string morpheo_statistics,
+                     std::string morpheo_vhdl      ,
+                     std::string morpheo_position  ,
+                     std::string morpheo_log       )
+{
+  if (not directory_initialized)
+    {
+      exist_directory(morpheo_statistics);
+      exist_directory(morpheo_vhdl      );
+      exist_directory(morpheo_position  );
+      exist_directory(morpheo_log       );
+
+      MORPHEO_STATISTICS = morpheo_statistics;
+      MORPHEO_VHDL       = morpheo_vhdl      ;
+      MORPHEO_POSITION   = morpheo_position  ;
+      MORPHEO_LOG        = morpheo_log       ;
+
+      directory_initialized = true;
+    }
+//   else
+//     {
+//       msg_printf(WARNING,_("Multi instance of Morpheo : directory, keep actual directory."));
+//     }
+}
+
+#undef  FUNCTION
+#define FUNCTION "directory"
+void directory (void)
+{
+  // with default value
+  directory_init();
+};
+
+}; //end namespace morpheo
Index: /trunk/IPs/systemC/processor/Morpheo/Common/src/Message.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/src/Message.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/src/Message.cpp	(revision 88)
@@ -0,0 +1,48 @@
+#ifdef LOG_FILE
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Common/include/Debug.h"
+#include "Common/include/Environment.h"
+#include "Common/include/ToString.h"
+#include "Common/include/ErrorMorpheo.h"
+#include <sys/types.h>
+#include <unistd.h>
+
+namespace morpheo {
+
+static bool log_initialized;
+FILE * log_stream;
+
+#undef  FUNCTION
+#define FUNCTION "log_init"
+void log_init (void)
+{
+  if (not log_initialized)
+    {
+      log_initialized = true;
+
+      directory();
+      
+      std::string filename = MORPHEO_LOG+"/Morpheo_"+toString<pid_t>(getpid())+".log";
+
+      log_stream = fopen (filename.c_str(), "w");
+
+      if (log_stream==NULL)
+        {
+          fprintf(stderr,_("%s Error create log file \"%s\", take the standard output.\n"),MSG_ERROR,filename.c_str());
+          log_stream = stdout;
+        }
+      else
+        {
+          fprintf(stdout,_("%s Create log file \"%s\".\n"),MSG_INFORMATION,filename.c_str());
+        }
+    }
+}
+
+}; // end namespace morpheo
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Common/src/Translation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Common/src/Translation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Common/src/Translation.cpp	(revision 88)
@@ -6,28 +6,29 @@
  */
 
-#include "../include/Translation.h"
-#include "../include/ErrorMorpheo.h"
+#include "Common/include/Environment.h"
+#include "Common/include/Translation.h"
+#include "Common/include/ErrorMorpheo.h"
 
 namespace morpheo {
 
-  Translation:: Translation (void)
+  static bool translation_initialized;
+
+  void translation (void)
   {
-#ifndef NO_TRANSLATION
-    char * top_level = getenv("MORPHEO_TOPLEVEL");
-    
-    if (top_level == NULL)
-      throw ERRORMORPHEO("Translation","Error morpheo environment is not positioned\n");
-  
-    std::string dirname = top_level;
-    dirname += "IPs/systemC/processor/Morpheo/locale";
+#ifdef TRANSLATION
+    if (not translation_initialized)
+      {
+        environment();
+        
+        std::string dirname = MORPHEO_TOPLEVEL;
+        dirname += "/IPs/systemC/processor/Morpheo/locale";
 
-    bindtextdomain(MORPHEO_PACKAGE,dirname.c_str());
+        if (bindtextdomain(MORPHEO_PACKAGE,dirname.c_str()) == NULL)
+          throw ERRORMORPHEO("Translation","Error in set directory containing message catalogs.\n");
+        
+        translation_initialized = true;
+      }
 #endif    
   }
 
-  Translation::~Translation (void)
-  {
-
-  }
-
 }; // end namespace morpheo
Index: /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Info/presentation-morpheo-microarchitecture.lang
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Info/presentation-morpheo-microarchitecture.lang	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Info/presentation-morpheo-microarchitecture.lang	(revision 88)
@@ -0,0 +1,1 @@
+en
Index: /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Info/presentation-morpheo-microarchitecture.type
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Info/presentation-morpheo-microarchitecture.type	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Info/presentation-morpheo-microarchitecture.type	(revision 88)
@@ -0,0 +1,1 @@
+ppt
Index: /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Info/presentation_bull.lang
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Info/presentation_bull.lang	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Info/presentation_bull.lang	(revision 88)
@@ -0,0 +1,1 @@
+fr
Index: /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Info/presentation_bull.type
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Info/presentation_bull.type	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Info/presentation_bull.type	(revision 88)
@@ -0,0 +1,1 @@
+ppt
Index: /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Makefile	(revision 88)
@@ -32,5 +32,4 @@
 DIR_SCHEMA_PNG		= Schema_png
 DIR_TEX			= Source
-DIR_LINK		= Link
 
 #--------------------------------------------------------------------------------
@@ -103,5 +102,4 @@
 			$(DVIPS) -o $@ $<;
 
-#$(DIR_LINK)/%/*
 %.dvi 			: $(DIR_TEX)/%.tex 
 			@\
@@ -170,7 +168,4 @@
 			$(MKDIR) $(DIR_DOCUMENTS)/$$FILENAME/$(DEFAULT_LANG);					\
 														\
-			$(ECHO) "Create link      : $(DIR_LINK)/$$FILENAME-$(DEFAULT_LANG)"; 			\
-			$(LINK_SYMBOLIC) $(DIR_DOCUMENTS)/$$FILENAME/$(DEFAULT_LANG) $(DIR_LINK)/$$FILENAME-$(DEFAULT_LANG); \
-														\
 			$(ECHO) "Create file      : $(DIR_DOCUMENTS)/$$FILENAME/$(DEFAULT_LANG)/root.tex"; 	\
 			$(TOUCH) $(DIR_DOCUMENTS)/$$FILENAME/$(DEFAULT_LANG)/root.tex
@@ -224,7 +219,5 @@
 														\
 			$(ECHO) "Delete directory : $(DIR_DOCUMENTS)/$$FILENAME";                    		\
-			$(RM) $(DIR_DOCUMENTS)/$$FILENAME;							\
-			$(ECHO) "Delete link      : $(DIR_DOCUMENTS)/$$FILENAME";                    		\
-			$(RM) $(DIR_LINK)/$$FILENAME-*;
+			$(RM) $(DIR_DOCUMENTS)/$$FILENAME;							
 
 rename			:
@@ -282,6 +275,5 @@
 														\
 			$(ECHO) "Rename directory : $(DIR_DOCUMENTS)/$$FILENAME_SRC";                    	\
-			$(MV) $(DIR_DOCUMENTS)/$$FILENAME_SRC     $(DIR_DOCUMENTS)/$$FILENAME_DEST;		\
-			$(ECHO) "Rename link      : manually please";
+			$(MV) $(DIR_DOCUMENTS)/$$FILENAME_SRC     $(DIR_DOCUMENTS)/$$FILENAME_DEST;		
 
 
Index: /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Schema/MORPHEO_micro_architecture-ex01.fig
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Schema/MORPHEO_micro_architecture-ex01.fig	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Schema/MORPHEO_micro_architecture-ex01.fig	(revision 88)
@@ -12,10 +12,4 @@
 	 5490 4140 4770 4140 4770 3690 5490 3690 5490 4140
 4 1 0 50 -1 -1 12 0.0000 4 135 450 5130 3960 decod\001
--6
-6 4770 3240 5490 3690
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
-	 5490 3690 4770 3690 4770 3240 5490 3240 5490 3690
-4 1 0 50 -1 -1 12 0.0000 4 105 570 5130 3420 context\001
-4 1 0 50 -1 -1 12 0.0000 4 105 390 5130 3600 state\001
 -6
 6 5850 3690 6570 4140
@@ -40,9 +34,4 @@
 4 1 0 50 -1 -1 12 0.0000 4 135 540 10170 2655 dcache\001
 -6
-6 6570 3015 7290 3465
-2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
-	 7290 3465 6570 3465 6570 3015 7290 3015 7290 3465
-4 1 0 50 -1 -1 12 0.0000 4 135 555 6930 3285 commit\001
--6
 6 3825 3060 4635 3510
 2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
@@ -60,4 +49,10 @@
 4 1 0 50 -1 -1 12 0.0000 4 150 300 2250 4050 port\001
 4 1 0 50 -1 -1 12 0.0000 4 135 495 2250 3870 icache\001
+-6
+6 4770 3240 5490 3690
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
+	 5490 3690 4770 3690 4770 3240 5490 3240 5490 3690
+4 1 0 50 -1 -1 12 0.0000 4 105 570 5130 3420 context\001
+4 1 0 50 -1 -1 12 0.0000 4 105 390 5130 3600 state\001
 -6
 2 1 0 1 0 7 50 -1 -1 4.000 0 0 -1 1 0 4
@@ -168,4 +163,6 @@
 	3 0 1.00 60.00 120.00
 	 3690 4050 4770 4050
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
+	 7290 3465 6570 3465 6570 3015 7290 3015 7290 3465
 4 1 0 50 -1 -1 12 0.0000 4 180 585 10170 4905 register\001
 4 1 0 50 -1 -1 12 1.5708 4 135 465 10935 3915 select\001
@@ -178,2 +175,3 @@
 4 1 0 50 -1 -1 12 0.0000 4 105 600 10170 4230 execute\001
 4 1 0 50 -1 -1 12 0.0000 4 135 600 10170 3690 memory\001
+4 1 0 50 -1 -1 12 0.0000 4 135 555 6930 3285 commit\001
Index: /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Schema/MORPHEO_micro_architecture-ex02.fig
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Schema/MORPHEO_micro_architecture-ex02.fig	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Schema/MORPHEO_micro_architecture-ex02.fig	(revision 88)
@@ -29,9 +29,4 @@
 4 1 0 50 -1 -1 12 0.0000 4 135 540 10170 2655 dcache\001
 -6
-6 6570 3015 7290 3465
-2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
-	 7290 3465 6570 3465 6570 3015 7290 3015 7290 3465
-4 1 0 50 -1 -1 12 0.0000 4 135 555 6930 3285 commit\001
--6
 6 4770 3285 5490 3735
 2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
@@ -39,25 +34,25 @@
 4 1 0 50 -1 -1 12 0.0000 4 135 450 5130 3555 decod\001
 -6
+6 3825 2655 4635 3105
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
+	 4590 3105 3870 3105 3870 2655 4590 2655 4590 3105
+4 1 0 50 -1 -1 12 0.0000 4 180 675 4230 2925 predictor\001
+-6
+6 2970 3285 3690 3735
+2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
+	 3690 3735 2970 3735 2970 3285 3690 3285 3690 3735
+4 1 0 50 -1 -1 12 0.0000 4 135 390 3330 3555 fetch\001
+-6
+6 1890 3690 2610 4140
+2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
+	 2610 4140 1890 4140 1890 3690 2610 3690 2610 4140
+4 1 0 50 -1 -1 12 0.0000 4 150 300 2250 4050 port\001
+4 1 0 50 -1 -1 12 0.0000 4 135 495 2250 3870 icache\001
+-6
 6 4770 2835 5490 3285
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
 	 5490 3285 4770 3285 4770 2835 5490 2835 5490 3285
 4 1 0 50 -1 -1 12 0.0000 4 105 570 5130 3015 context\001
 4 1 0 50 -1 -1 12 0.0000 4 105 390 5130 3195 state\001
--6
-6 3825 2655 4635 3105
-2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
-	 4590 3105 3870 3105 3870 2655 4590 2655 4590 3105
-4 1 0 50 -1 -1 12 0.0000 4 180 675 4230 2925 predictor\001
--6
-6 2970 3285 3690 3735
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
-	 3690 3735 2970 3735 2970 3285 3690 3285 3690 3735
-4 1 0 50 -1 -1 12 0.0000 4 135 390 3330 3555 fetch\001
--6
-6 1890 3690 2610 4140
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
-	 2610 4140 1890 4140 1890 3690 2610 3690 2610 4140
-4 1 0 50 -1 -1 12 0.0000 4 150 300 2250 4050 port\001
-4 1 0 50 -1 -1 12 0.0000 4 135 495 2250 3870 icache\001
 -6
 2 1 0 1 0 7 50 -1 -1 4.000 0 0 -1 1 0 3
@@ -204,11 +199,13 @@
 	 1710 5535 12510 5535 12510 2295 1710 2295 1710 5535
 2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
+	 5490 4095 4770 4095 4770 4545 5490 4545 5490 4095
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
+	 4590 4725 3870 4725 3870 5175 4590 5175 4590 4725
+2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
+	 3690 4095 2970 4095 2970 4545 3690 4545 3690 4095
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
+	 7290 3465 6570 3465 6570 3015 7290 3015 7290 3465
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
 	 5490 4545 4770 4545 4770 4995 5490 4995 5490 4545
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
-	 5490 4095 4770 4095 4770 4545 5490 4545 5490 4095
-2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
-	 4590 4725 3870 4725 3870 5175 4590 5175 4590 4725
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
-	 3690 4095 2970 4095 2970 4545 3690 4545 3690 4095
 4 1 0 50 -1 -1 12 0.0000 4 180 585 10170 4905 register\001
 4 1 0 50 -1 -1 12 1.5708 4 135 465 10935 3915 select\001
@@ -226,2 +223,3 @@
 4 1 0 50 -1 -1 12 0.0000 4 105 570 5130 4860 context\001
 4 1 0 50 -1 -1 12 0.0000 4 180 675 4230 4995 predictor\001
+4 1 0 50 -1 -1 12 0.0000 4 135 555 6930 3285 commit\001
Index: /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Schema/MORPHEO_micro_architecture-ex03.fig
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Schema/MORPHEO_micro_architecture-ex03.fig	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Schema/MORPHEO_micro_architecture-ex03.fig	(revision 88)
@@ -128,5 +128,4 @@
 4 1 0 50 -1 -1 12 0.0000 4 135 540 10170 7695 dcache\001
 -6
-6 1890 3600 7650 6660
 6 5850 4995 6570 5445
 2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
@@ -134,9 +133,4 @@
 4 1 0 50 -1 -1 12 0.0000 4 90 555 6210 5265 rename\001
 -6
-6 6570 4320 7290 4770
-2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
-	 7290 4770 6570 4770 6570 4320 7290 4320 7290 4770
-4 1 0 50 -1 -1 12 0.0000 4 135 555 6930 4590 commit\001
--6
 6 4770 4590 5490 5040
 2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
@@ -144,26 +138,50 @@
 4 1 0 50 -1 -1 12 0.0000 4 135 450 5130 4860 decod\001
 -6
+6 3825 3960 4635 4410
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
+	 4590 4410 3870 4410 3870 3960 4590 3960 4590 4410
+4 1 0 50 -1 -1 12 0.0000 4 180 675 4230 4230 predictor\001
+-6
+6 2970 4590 3690 5040
+2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
+	 3690 5040 2970 5040 2970 4590 3690 4590 3690 5040
+4 1 0 50 -1 -1 12 0.0000 4 135 390 3330 4860 fetch\001
+-6
+6 1890 4995 2610 5445
+2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
+	 2610 5445 1890 5445 1890 4995 2610 4995 2610 5445
+4 1 0 50 -1 -1 12 0.0000 4 150 300 2250 5355 port\001
+4 1 0 50 -1 -1 12 0.0000 4 135 495 2250 5175 icache\001
+-6
 6 4770 4140 5490 4590
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
 	 5490 4590 4770 4590 4770 4140 5490 4140 5490 4590
 4 1 0 50 -1 -1 12 0.0000 4 105 570 5130 4320 context\001
 4 1 0 50 -1 -1 12 0.0000 4 105 390 5130 4500 state\001
 -6
-6 3825 3960 4635 4410
-2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
-	 4590 4410 3870 4410 3870 3960 4590 3960 4590 4410
-4 1 0 50 -1 -1 12 0.0000 4 180 675 4230 4230 predictor\001
--6
-6 2970 4590 3690 5040
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
-	 3690 5040 2970 5040 2970 4590 3690 4590 3690 5040
-4 1 0 50 -1 -1 12 0.0000 4 135 390 3330 4860 fetch\001
--6
-6 1890 4995 2610 5445
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
-	 2610 5445 1890 5445 1890 4995 2610 4995 2610 5445
-4 1 0 50 -1 -1 12 0.0000 4 150 300 2250 5355 port\001
-4 1 0 50 -1 -1 12 0.0000 4 135 495 2250 5175 icache\001
--6
+2 1 0 1 0 7 50 -1 20 3.000 0 0 -1 1 0 2
+	3 0 1.00 60.00 120.00
+	 8010 3915 8370 3915
+2 1 0 1 0 7 50 -1 -1 3.000 0 0 -1 1 0 4
+	3 0 1.00 60.00 120.00
+	 11970 3915 12150 3915 12150 3240 8010 3240
+2 1 0 1 0 7 50 -1 -1 4.000 0 0 -1 1 1 2
+	3 0 1.00 60.00 120.00
+	3 0 1.00 60.00 120.00
+	 10170 2925 10170 3420
+2 1 0 1 0 7 50 -1 -1 4.000 0 0 -1 1 1 2
+	3 0 1.00 60.00 120.00
+	3 0 1.00 60.00 120.00
+	 10170 7020 10170 7515
+2 2 2 1 0 7 50 -1 -1 3.000 0 0 -1 0 0 5
+	 1710 8145 12510 8145 12510 2295 1710 2295 1710 8145
+2 4 0 1 0 7 50 -1 20 3.000 0 0 8 0 0 5
+	 8010 2880 8010 7560 7650 7560 7650 2880 8010 2880
+2 1 0 1 0 7 50 -1 20 3.000 0 0 -1 1 0 2
+	3 0 1.00 60.00 120.00
+	 8010 6525 8370 6525
+2 1 0 1 0 7 50 -1 -1 3.000 0 0 -1 1 0 4
+	3 0 1.00 60.00 120.00
+	 11970 6525 12150 6525 12150 7200 8010 7200
 2 1 0 1 0 7 50 -1 -1 4.000 0 0 -1 1 0 3
 	3 0 1.00 60.00 120.00
@@ -256,11 +274,16 @@
 	 6930 4320 6930 4095 6030 4095 5130 3645 5130 4140
 2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
+	 5490 5400 4770 5400 4770 5850 5490 5850 5490 5400
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
+	 4590 6030 3870 6030 3870 6480 4590 6480 4590 6030
+2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
+	 3690 5400 2970 5400 2970 5850 3690 5850 3690 5400
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
+	 7290 4770 6570 4770 6570 4320 7290 4320 7290 4770
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
 	 5490 5850 4770 5850 4770 6300 5490 6300 5490 5850
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
-	 5490 5400 4770 5400 4770 5850 5490 5850 5490 5400
-2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
-	 4590 6030 3870 6030 3870 6480 4590 6480 4590 6030
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
-	 3690 5400 2970 5400 2970 5850 3690 5850 3690 5400
+4 0 1 50 -1 -1 12 0.0000 4 135 360 1710 2205 Core\001
+4 0 1 50 -1 -1 12 0.0000 4 180 1185 8190 3015 Execution Loop\001
+4 1 0 50 -1 -1 12 1.5708 4 135 465 7875 5220 select\001
 4 0 1 50 -1 -1 12 0.0000 4 180 1575 5760 3825 Out Of Order Engine\001
 4 0 1 50 -1 -1 12 0.0000 4 135 750 2790 3735 Front End\001
@@ -270,30 +293,3 @@
 4 1 0 50 -1 -1 12 0.0000 4 105 570 5130 6165 context\001
 4 1 0 50 -1 -1 12 0.0000 4 180 675 4230 6300 predictor\001
--6
-2 1 0 1 0 7 50 -1 20 3.000 0 0 -1 1 0 2
-	3 0 1.00 60.00 120.00
-	 8010 3915 8370 3915
-2 1 0 1 0 7 50 -1 -1 3.000 0 0 -1 1 0 4
-	3 0 1.00 60.00 120.00
-	 11970 3915 12150 3915 12150 3240 8010 3240
-2 1 0 1 0 7 50 -1 -1 4.000 0 0 -1 1 1 2
-	3 0 1.00 60.00 120.00
-	3 0 1.00 60.00 120.00
-	 10170 2925 10170 3420
-2 1 0 1 0 7 50 -1 -1 4.000 0 0 -1 1 1 2
-	3 0 1.00 60.00 120.00
-	3 0 1.00 60.00 120.00
-	 10170 7020 10170 7515
-2 2 2 1 0 7 50 -1 -1 3.000 0 0 -1 0 0 5
-	 1710 8145 12510 8145 12510 2295 1710 2295 1710 8145
-2 4 0 1 0 7 50 -1 20 3.000 0 0 8 0 0 5
-	 8010 2880 8010 7560 7650 7560 7650 2880 8010 2880
-2 1 0 1 0 7 50 -1 20 3.000 0 0 -1 1 0 2
-	3 0 1.00 60.00 120.00
-	 8010 6525 8370 6525
-2 1 0 1 0 7 50 -1 -1 3.000 0 0 -1 1 0 4
-	3 0 1.00 60.00 120.00
-	 11970 6525 12150 6525 12150 7200 8010 7200
-4 0 1 50 -1 -1 12 0.0000 4 135 360 1710 2205 Core\001
-4 0 1 50 -1 -1 12 0.0000 4 180 1185 8190 3015 Execution Loop\001
-4 1 0 50 -1 -1 12 1.5708 4 135 465 7875 5220 select\001
+4 1 0 50 -1 -1 12 0.0000 4 135 555 6930 4590 commit\001
Index: /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Schema/MORPHEO_micro_architecture-ex04.fig
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Schema/MORPHEO_micro_architecture-ex04.fig	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Documentation/Source/Schema/MORPHEO_micro_architecture-ex04.fig	(revision 88)
@@ -157,5 +157,10 @@
 	 7470 4320 5760 4320 5760 2610 7470 2610 7470 4320
 -6
-6 2790 2880 5580 4320
+6 1890 6300 2610 6750
+2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
+	 2610 6750 1890 6750 1890 6300 2610 6300 2610 6750
+4 1 0 50 -1 -1 12 0.0000 4 150 300 2250 6660 port\001
+4 1 0 50 -1 -1 12 0.0000 4 135 495 2250 6480 icache\001
+-6
 6 4770 3690 5490 4140
 2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
@@ -163,48 +168,19 @@
 4 1 0 50 -1 -1 12 0.0000 4 135 450 5130 3960 decod\001
 -6
+6 3825 3060 4635 3510
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
+	 4590 3510 3870 3510 3870 3060 4590 3060 4590 3510
+4 1 0 50 -1 -1 12 0.0000 4 180 675 4230 3330 predictor\001
+-6
+6 2970 3690 3690 4140
+2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
+	 3690 4140 2970 4140 2970 3690 3690 3690 3690 4140
+4 1 0 50 -1 -1 12 0.0000 4 135 390 3330 3960 fetch\001
+-6
 6 4770 3240 5490 3690
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
 	 5490 3690 4770 3690 4770 3240 5490 3240 5490 3690
 4 1 0 50 -1 -1 12 0.0000 4 105 570 5130 3420 context\001
 4 1 0 50 -1 -1 12 0.0000 4 105 390 5130 3600 state\001
--6
-6 3825 3060 4635 3510
-2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
-	 4590 3510 3870 3510 3870 3060 4590 3060 4590 3510
-4 1 0 50 -1 -1 12 0.0000 4 180 675 4230 3330 predictor\001
--6
-6 2970 3690 3690 4140
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
-	 3690 4140 2970 4140 2970 3690 3690 3690 3690 4140
-4 1 0 50 -1 -1 12 0.0000 4 135 390 3330 3960 fetch\001
--6
-2 1 0 1 0 31 50 -1 -1 4.000 0 0 -1 1 1 3
-	3 0 1.00 60.00 120.00
-	3 0 1.00 60.00 120.00
-	 4410 3510 4410 3870 4770 3870
-2 1 0 1 0 31 50 -1 -1 4.000 0 0 -1 1 1 3
-	3 0 1.00 60.00 120.00
-	3 0 1.00 60.00 120.00
-	 4050 3510 4050 3870 3690 3870
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
-	3 0 1.00 60.00 120.00
-	 3780 3960 4770 3960
-2 4 0 1 0 11 51 -1 20 0.000 0 0 7 0 0 5
-	 3780 4050 3060 4050 3060 3600 3780 3600 3780 4050
-2 1 0 1 0 31 50 -1 -1 4.000 0 0 -1 1 1 3
-	3 0 1.00 60.00 120.00
-	3 0 1.00 60.00 120.00
-	 3960 3510 3960 3780 3780 3780
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
-	3 0 1.00 60.00 120.00
-	 3690 4050 4770 4050
-2 2 2 1 0 7 50 -1 -1 3.000 0 0 -1 0 0 5
-	 5580 2880 2790 2880 2790 4320 5580 4320 5580 2880
--6
-6 1890 6300 2610 6750
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
-	 2610 6750 1890 6750 1890 6300 2610 6300 2610 6750
-4 1 0 50 -1 -1 12 0.0000 4 150 300 2250 6660 port\001
-4 1 0 50 -1 -1 12 0.0000 4 135 495 2250 6480 icache\001
 -6
 2 1 0 1 0 7 50 -1 -1 4.000 0 0 -1 1 0 3
@@ -292,6 +268,4 @@
 	 3690 6390 4770 6390
 2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
-	 5490 6750 4770 6750 4770 7200 5490 7200 5490 6750
-2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
 	 5490 6300 4770 6300 4770 6750 5490 6750 5490 6300
 2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
@@ -314,4 +288,28 @@
 2 4 0 1 0 11 50 -1 20 4.000 0 0 7 0 0 5
 	 6570 6300 5850 6300 5850 6750 6570 6750 6570 6300
+2 1 0 1 0 31 50 -1 -1 4.000 0 0 -1 1 1 3
+	3 0 1.00 60.00 120.00
+	3 0 1.00 60.00 120.00
+	 4410 3510 4410 3870 4770 3870
+2 1 0 1 0 31 50 -1 -1 4.000 0 0 -1 1 1 3
+	3 0 1.00 60.00 120.00
+	3 0 1.00 60.00 120.00
+	 4050 3510 4050 3870 3690 3870
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	3 0 1.00 60.00 120.00
+	 3780 3960 4770 3960
+2 4 0 1 0 11 51 -1 20 0.000 0 0 7 0 0 5
+	 3780 4050 3060 4050 3060 3600 3780 3600 3780 4050
+2 1 0 1 0 31 50 -1 -1 4.000 0 0 -1 1 1 3
+	3 0 1.00 60.00 120.00
+	3 0 1.00 60.00 120.00
+	 3960 3510 3960 3780 3780 3780
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	3 0 1.00 60.00 120.00
+	 3690 4050 4770 4050
+2 2 2 1 0 7 50 -1 -1 3.000 0 0 -1 0 0 5
+	 5580 2880 2790 2880 2790 4320 5580 4320 5580 2880
+2 4 0 1 0 31 50 -1 20 4.000 0 0 7 0 0 5
+	 5490 6750 4770 6750 4770 7200 5490 7200 5490 6750
 4 0 1 50 -1 -1 12 0.0000 4 135 360 1710 2205 Core\001
 4 0 1 50 -1 -1 12 0.0000 4 180 1575 5760 2520 Out Of Order Engine\001
@@ -324,4 +322,4 @@
 4 1 0 50 -1 -1 12 0.0000 4 105 570 5130 7065 context\001
 4 1 0 50 -1 -1 12 0.0000 4 180 675 4230 7200 predictor\001
-4 1 0 50 -1 -1 12 6.2832 4 135 555 6930 7245 commit\001
-4 1 0 50 -1 -1 12 6.2832 4 90 555 6210 6525 rename\001
+4 1 0 50 -1 -1 12 0.0000 4 135 555 6930 7245 commit\001
+4 1 0 50 -1 -1 12 0.0000 4 90 555 6210 6525 rename\001
